#import <Foundation/Foundation.h>
#import <syslog.h>
#import <stdarg.h>
#import <libgen.h>
#import <unistd.h>
#import "shouldrun.h"

int main (int argc, const char * argv[]) {
	bool oughtToLaunch=false;
	arbiter_sr arbiterResult=0;
	NSDictionary *dict=nil;
	char *bn=basename(argv[1]);
	
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

	// load the options dictionary, if it exists...
	//dict=[NSDictionary dictionaryWithContentsOfFile:@"/etc/launcharbiter.plist"];
	dict=[NSDictionary dictionaryWithContentsOfFile:@"/Users/leeg/launcharbiter.plist"];

	switch((arbiterResult=shouldrun(bn,dict)))
	{
		case ARBITER_RUN:
			syslog(LOG_NOTICE,"going to run %s",bn);
			oughtToLaunch=true;
			break;
		case ARBITER_VETO_BATTERY:
			syslog(LOG_WARNING,"powered by battery, not running %s",bn);
			break;
		case ARBITER_VETO_USERDENIED:
			syslog(LOG_WARNING,"user %s may not run %s",getlogin(),bn);
			break;
		default:
			//this episode of Sesame Street was brought to you by the letters W, T and F :-)
			syslog(LOG_ERR,"something weird happened and I don't know what, %s won't be run",bn);
			exit(EXIT_FAILURE);
			//get here if you can
			break;
	}
    [pool release];
	//now exec the program
	argv++;
	if(oughtToLaunch) execv(argv[0],argv);
    return 0;
}
